import "choerodon-ui/pro/lib/data-set/style";
import _DataSet from "choerodon-ui/pro/lib/data-set";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { createContext, useContext, useEffect, useMemo } from 'react';
import { observer } from 'mobx-react-lite';
import { inject } from 'mobx-react';
import baseDeployDataSet from "./baseDeployDataSet";
import hostSettingDataSet from "./hostSettingDataSet";
import paramSettingDataSet from "./paramSettingDataSet";
import serviceVersionDataSet from "./serviceVersionDataSet";
import useStore from "./useStore";
import pvLabelsDataSet from "./pvLabelsDataSet";
var Store = /*#__PURE__*/createContext();
export function useBaseComDeployStore() {
  return useContext(Store);
}
export var StoreProvider = inject('AppState')(observer(function (props) {
  var projectId = props.AppState.currentMenuType.projectId,
      children = props.children,
      random = props.random;
  var BaseComDeployStore = useStore();
  var HostSettingDataSet = useMemo(function () {
    return new _DataSet(hostSettingDataSet(projectId, BaseComDeployStore, random));
  }, [projectId, random]);
  var ServiceVersionDataSet = useMemo(function () {
    return new _DataSet(serviceVersionDataSet());
  }, []);
  var BaseDeployDataSet = useMemo(function () {
    return new _DataSet(baseDeployDataSet(projectId, HostSettingDataSet, BaseComDeployStore, ServiceVersionDataSet));
  }, [projectId, random]);
  var ParamSettingDataSet = useMemo(function () {
    return new _DataSet(paramSettingDataSet(BaseDeployDataSet));
  }, [BaseDeployDataSet]);
  var PVLabelsDataSet = useMemo(function () {
    return new _DataSet(pvLabelsDataSet(projectId, BaseDeployDataSet, BaseComDeployStore));
  }, [projectId, BaseDeployDataSet]);

  var value = _objectSpread(_objectSpread({}, props), {}, {
    BaseDeployDataSet: BaseDeployDataSet,
    HostSettingDataSet: HostSettingDataSet,
    ParamSettingDataSet: ParamSettingDataSet,
    BaseComDeployStore: BaseComDeployStore,
    PVLabelsDataSet: PVLabelsDataSet,
    ServiceVersionDataSet: ServiceVersionDataSet
  });

  return /*#__PURE__*/React.createElement(Store.Provider, {
    value: value
  }, children);
}));